/*
 * Copyright (c) 2015 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

 /*global
    setGallery: false,
 */

var refreshed = false,
    filter = new tizen.AttributeFilter(
        'type',
        'EXACTLY',
        'IMAGE'
    ),
    sortMode = new tizen.SortMode(
        'title',
        'ASC'
    ),
    RESOURCE_PATH = '/opt/usr/media/';

function extractPathData(fileUri) {
    var filepath = '',
        parts = [],
        name = '',
        path = '',
        resource = '',
        directory = '';

    filepath = fileUri.replace('file://', ''); // file path from URI
    parts = filepath.split('/'); // split the path

    // get filename and remove it from the path parts
    name = parts.pop();
    directory = parts[parts.length - 1]; // get directory name
    path = parts.join('/'); // get directory path
    resource = path.replace(RESOURCE_PATH, ''); // resource path
    resource = resource.replace(
        /^[^\/]+/,
        function lowerText(text) {
            return text.toLowerCase();
        }
    );
    return {
        name: name,
        path: path,
        resource: resource,
        directory: directory
    };
}

function contentFindSuccess(items) {
    var length = items.length,
        i = 0,
        item = null,
        pathdata = null,
        allpath,
        array_allpath = [];

    // fill galleries array with new images
    for (i = 0; i < length; i += 1) {
        item = items[i];
        pathdata = extractPathData(item.contentURI);
        item.path = pathdata.path;
        item.resource = pathdata.resource;
        item.directory = pathdata.directory;
        allpath = "file://"+ item.path + "/" + item.name;
        array_allpath.push(allpath);
    }

    setGallery(array_allpath);
    refreshed = true;
}

function contentFindError(e) {
    galleries.length = 0;
    console.warn('Content API find() failed!', e);
}

function refreshGalleries() {
    refreshed = false;
    tizen.content.find(
        contentFindSuccess,
        contentFindError,
        null,
        filter,
        sortMode
    );
}